/**********************************
// Scott Enzinna
// Make
// Fall 2014
// The Low Rider
**********************************/

// This library is used to play the songs with the buzzer
#include <TimerFreeTone.h>
// This library is used to move the servos
#include <Servo.h>
// This library is used to with the servo library
#include <Wire.h>
// This library is used to interact with the IR remote
#include "IRremote.h"
// This is the header fle that has the #defines for buttons on the remote
#include "header.h"

// These are the two servo ojects that will control the left and the right wheel
Servo myservo;
Servo myservo_2;

// IR resources
int RECV_PIN = 11;  // This is the pin that will be used for the IR reciever
IRrecv irrecv(RECV_PIN);
decode_results results;

// Setup
void setup()
{
  irrecv.enableIRIn(); // Start the receiver
  myservo.attach(9); // Servo 1 gets sets to pin 9
  myservo_2.attach(6); // Servo 2 get sets to pin 6
  myservo.write(20); // Servo 1 to 85 degrees
  myservo_2.write(85); //Servo 2 to 85 degrees
  
  // set pins 2,3,4,5 as output pins and set to low
  for (int i = 2; i<6; i++)
  {
    pinMode(i, OUTPUT);
    digitalWrite(i, LOW);
  }
}

// Main loop
void loop()
{
  //has a transmission been received?
  if (irrecv.decode(&results))
  {
    //when the value recieved is equial to the number defined by vol_up
    if (results.value == vol_up)
    {
      myservo_2.write(10);  // This will set the second servo to 90 degrees
    }
    
    //when the value recieved is equial to the number defined by vol_down
    if (results.value == vol_down)
    {
      myservo_2.write(95); // This will set the second servo to 0 degrees
    }
    
    //when the value recieved is equial to the number defined by ch_down
    if (results.value == ch_down)
    {
      myservo.write(10); // This will set the first servo to 0 degrees   
    }
    
    //when the value recieved is equial to the number defined by ch_up
    if (results.value == ch_up)
    {
      myservo.write(95); // This will set the first servo to 90 degrees
    }
    
    //when the value recieved is equial to the number defined by mult
    if (results.value == mult)
    {
      Play_Second_Song(); // This will call the function that will play the secind song
    }

    //when the value recieved is equial to the number defined by back
    if (results.value == back)
    {
      Play_First_Song(); // This will call the function that will play the first song
    }

    //when the value recieved is equial to the number defined by zero
    if (results.value == zero)
    {
      Lock(); // This will call the lock function that will simulate the car locking
    }

    //when the value recieved is equial to the number defined by one
    if (results.value == one)
    {
      Headlights_Off(); // This will call the function that will turn the headlights off
    }
    
    //when the value recieved is equial to the number defined by two
    if (results.value == two)
    {
      Headlights_On(); // This will call the function that will turn the headlights on
    }
    
    //when the value recieved is equial to the number defined by four
    if (results.value == four)
    {
      Both_Servos_Down(); // This will call a function that will lower servos to 0 degrees
    }
    
    //when the value recieved is equial to the number defined by five
    if (results.value == five)
    {
      Both_Servos_Up(); // This will call a function that will raise both servos to 90 degrees
    }
    
    //when the value recieved is equial to the number defined by seven
    if (results.value == seven)
    {
      Taillights_Off(); // This will call a function that will turn both of the taillights off
    }
    
    //when the value recieved is equial to the number defined by eight
    if (results.value == eight)
    {
      Taillights_On(); // This will call a function that will turn both of the taillights on
    }
    
    // Receive the next value
    irrecv.resume();
  }
}
